//------------------------------------------------------------------
// not for sale, rent, auction, nor lease
// January 31st, 2020
// Fibo # 0, 1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144, 233, 377, 610, 987,  ...
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
#property description "not for sale, rent, auction, nor lease"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 10  

#property indicator_color9  clrNONE // C'0,180,0'
#property indicator_color10 clrCrimson

#property indicator_color7  C'0,160,0'
#property indicator_color8  C'154,5,39'

#property indicator_color5  C'0,140,0'
#property indicator_color6  C'144,5,39'

#property indicator_color3  C'0,120,0'
#property indicator_color4  C'134,5,39'
#property indicator_color1  C'0,100,0' // C'0,100,0' //clrDarkGreen
#property indicator_color2  clrNONE //C'124,5,39'

#property indicator_minimum 0
#property indicator_maximum 6

enum enTimeFrames
{
   tf_cu  = 0,              // current time frame
   tf_m1  = PERIOD_M1,      // 1 minute
   tf_m5  = PERIOD_M5,      // 5 minutes
   tf_m15 = PERIOD_M15,     // 15 minutes
   tf_m30 = PERIOD_M30,     // 30 minutes
   tf_h1  = PERIOD_H1,      // 1 hour
   tf_h4  = PERIOD_H4,      // 4 hours
   tf_d1  = PERIOD_D1,      // daily
   tf_w1  = PERIOD_W1,      // weekly
   tf_mb1 = PERIOD_MN1      // monthly
};

enum PriceMenu
{
   Low_High  = 0,      
   Close_Close = 1      
};

extern string         UniqueID             = "Stochastic Signals";
extern int            MaximumCandlesToDisplay = 287;
extern string         note1="-------------------------------------";
extern enTimeFrames   TimeFrame1           = tf_cu;
extern int            StochasticK1         = 38;
extern int            StochasticD1         = 8;
extern int            StochasticSlowing1   = 2;
extern PriceMenu      StochasticPrice1     = Close_Close;
extern ENUM_MA_METHOD SignalLineMaMethod1  = MODE_EMA;
extern int            WingdingsFontSymbol1 = 233;
extern string         note2="-------------------------------------";
extern enTimeFrames   TimeFrame2           = tf_cu;
extern int            StochasticK2         = 38;
extern int            StochasticD2         = 11;
extern int            StochasticSlowing2   = 5;
extern PriceMenu      StochasticPrice2     = Close_Close;
extern ENUM_MA_METHOD SignalLineMaMethod2  = MODE_EMA;
extern int            WingdingsFontSymbol2 = 110;
extern string         note3="-------------------------------------";
extern enTimeFrames   TimeFrame3           = tf_cu;
extern int            StochasticK3         = 38;
extern int            StochasticD3         = 10;
extern int            StochasticSlowing3   = 4;
extern PriceMenu      StochasticPrice3     = Close_Close;
extern ENUM_MA_METHOD SignalLineMaMethod3  = MODE_EMA;
extern int            WingdingsFontSymbol3 = 110;
extern string         note4="-------------------------------------";
extern enTimeFrames   TimeFrame4           = tf_cu;
extern int            StochasticK4         = 38;
extern int            StochasticD4         = 9;
extern int            StochasticSlowing4   = 3;
extern PriceMenu      StochasticPrice4     = Close_Close;
extern ENUM_MA_METHOD SignalLineMaMethod4  = MODE_EMA;
extern int            WingdingsFontSymbol4 = 108;
extern string         note5="-------------------------------------";
extern enTimeFrames   TimeFrame5           = tf_cu;
extern int            StochasticK5         = 38;
extern int            StochasticD5         = 8;
extern int            StochasticSlowing5   = 2;
extern PriceMenu      StochasticPrice5     = Close_Close;
extern ENUM_MA_METHOD SignalLineMaMethod5  = MODE_EMA;
extern int            WingdingsFontSymbol5 = 234;
extern string         note6="-------------------------------------";

extern int    LinesWidth            = 0;
extern color  LabelsColor           = clrBrown;
extern int    LabelsHorizontalShift = 5;
extern double LabelsVerticalShift   = 1.5;
extern bool   alertsOn              = false;
extern int    alertsLevel           = 7;
extern bool   alertsMessage         = false;
extern bool   alertsSound           = false;
extern bool   alertsEmail           = false;
extern bool   alertsOnEachBar       = false;

double sto1u[], sto1d[], sto2u[], sto2d[], sto3u[], sto3d[], sto4u[], sto4d[], sto5u[], sto5d[];

int    timeFrames[5];
bool   returnBars;
string indicatorFileName;
//------------------------------------------------------------------
int OnInit()
{
      SetIndexBuffer(0,sto1u);
      SetIndexBuffer(1,sto1d);
      SetIndexBuffer(2,sto2u);
      SetIndexBuffer(3,sto2d);
      SetIndexBuffer(4,sto3u);
      SetIndexBuffer(5,sto3d);
      SetIndexBuffer(6,sto4u);
      SetIndexBuffer(7,sto4d);
      SetIndexBuffer(8,sto5u);
      SetIndexBuffer(9,sto5d);

      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame1=="returnBars"); if (returnBars) return(0);
      
      for (int i=0; i<indicator_buffers; i++) 
         SetIndexStyle(i,DRAW_ARROW,EMPTY,LinesWidth);  

      SetIndexArrow(0,WingdingsFontSymbol1);
      SetIndexArrow(1,WingdingsFontSymbol1);
      SetIndexArrow(2,WingdingsFontSymbol2);
      SetIndexArrow(3,WingdingsFontSymbol2);
      SetIndexArrow(4,WingdingsFontSymbol3);
      SetIndexArrow(5,WingdingsFontSymbol3);
      SetIndexArrow(6,WingdingsFontSymbol4);
      SetIndexArrow(7,WingdingsFontSymbol4);
      
      SetIndexArrow(8,WingdingsFontSymbol5);
      SetIndexArrow(9,WingdingsFontSymbol5);

        timeFrames[0]         = MathMax(TimeFrame1,_Period);
        timeFrames[1]         = MathMax(TimeFrame2,_Period);
        timeFrames[2]         = MathMax(TimeFrame3,_Period);
        timeFrames[3]         = MathMax(TimeFrame4,_Period);
        timeFrames[4]         = MathMax(TimeFrame5,_Period);

      alertsLevel = MathMin(MathMax(alertsLevel,4),indicator_buffers/2);
      IndicatorShortName(UniqueID);
   return(0);
}
//+-------------------------------------------------------------------
int deinit()
{
   for (int t=0; t<indicator_buffers/2; t++) ObjectDelete(UniqueID+t);
   return(0); 
}
//------------------------------------------------------------------
double trend[][2];
#define _up 0
#define _dn 1
int start()
{
         int i,r,counted_bars=IndicatorCounted(), myPriceField1, myPriceField2, myPriceField3, myPriceField4, myPriceField5;
         
         myPriceField1 = StochasticPrice1;
         myPriceField2 = StochasticPrice2;
         myPriceField3 = StochasticPrice3;
         myPriceField4 = StochasticPrice4;
         myPriceField5 = StochasticPrice5;
   
         if(counted_bars < 0) return(-1);
         if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { sto1u[0] = limit+1; return(0); }

         if (timeFrames[0] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[0],indicatorFileName,"returnBars",0,0)*timeFrames[0]/Period()));
         limit = MaximumCandlesToDisplay;
         if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);
        
         bool initialized = false;
         if (!initialized)
         {
               initialized = true;
               int window = WindowFind(UniqueID);

               string label1 = timeFrameToString (timeFrames[0]) + " (" + IntegerToString(StochasticK1)  +","+ IntegerToString(StochasticD1)+","+ IntegerToString(StochasticSlowing1) + ")";
               ObjectCreate (UniqueID+0,OBJ_TEXT,window,0,0);
               ObjectSet    (UniqueID+0,OBJPROP_COLOR,LabelsColor);
               ObjectSet    (UniqueID+0,OBJPROP_PRICE1,0+LabelsVerticalShift);
               ObjectSetText(UniqueID+0,label1,7,"Arial");
               ObjectSet    (UniqueID+0,OBJPROP_TIME1,Time[0]+Period()*LabelsHorizontalShift*60);

               string label2 = timeFrameToString (timeFrames[1]) + " (" + IntegerToString(StochasticK2)  +","+ IntegerToString(StochasticD2)+","+ IntegerToString(StochasticSlowing2) + ")";
               ObjectCreate(UniqueID+1,OBJ_TEXT,window,0,0);
               ObjectSet(UniqueID+1,OBJPROP_COLOR,LabelsColor);
               ObjectSet(UniqueID+1,OBJPROP_PRICE1,1+LabelsVerticalShift);
               ObjectSetText(UniqueID+1,label2,7,"Arial");
               ObjectSet(UniqueID+1,OBJPROP_TIME1,Time[0]+Period()*LabelsHorizontalShift*60);

               string label3 = timeFrameToString (timeFrames[2]) + " (" + IntegerToString(StochasticK3)  +","+ IntegerToString(StochasticD3)+","+ IntegerToString(StochasticSlowing3) + ")";
               ObjectCreate(UniqueID+2,OBJ_TEXT,window,0,0);
               ObjectSet(UniqueID+2,OBJPROP_COLOR,LabelsColor);
               ObjectSet(UniqueID+2,OBJPROP_PRICE1,2+LabelsVerticalShift);
               ObjectSetText(UniqueID+2,label3,7,"Arial");
               ObjectSet(UniqueID+2,OBJPROP_TIME1,Time[0]+Period()*LabelsHorizontalShift*60);

               string label4 = timeFrameToString (timeFrames[3]) + " (" + IntegerToString(StochasticK4)  +","+ IntegerToString(StochasticD4)+","+ IntegerToString(StochasticSlowing4) + ")";
               ObjectCreate(UniqueID+3,OBJ_TEXT,window,0,0);
               ObjectSet(UniqueID+3,OBJPROP_COLOR,LabelsColor);
               ObjectSet(UniqueID+3,OBJPROP_PRICE1,3+LabelsVerticalShift);
               ObjectSetText(UniqueID+3,label4,7,"Arial");
               ObjectSet(UniqueID+3,OBJPROP_TIME1,Time[0]+Period()*LabelsHorizontalShift*60);

               string label5 = timeFrameToString (timeFrames[4]) + " (" + IntegerToString(StochasticK5)  +","+ IntegerToString(StochasticD5)+","+ IntegerToString(StochasticSlowing5) + ")";
               ObjectCreate(UniqueID+4,OBJ_TEXT,window,0,0);
               ObjectSet(UniqueID+4,OBJPROP_COLOR,LabelsColor);
               ObjectSet(UniqueID+4,OBJPROP_PRICE1,4+LabelsVerticalShift);
               ObjectSetText(UniqueID+4,label5,7,"Arial");
               ObjectSet(UniqueID+4,OBJPROP_TIME1,Time[0]+Period()*LabelsHorizontalShift*60);
         }
    
   for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
   {
      trend[r][_up] = 0;
      trend[r][_dn] = 0;
      for (int k=0; k<indicator_buffers/2; k++)
      {
            int y = iBarShift(NULL,timeFrames[k],Time[i]);
            double stochm1 = iStochastic(NULL,timeFrames[k],StochasticK1,StochasticD1,StochasticSlowing1,SignalLineMaMethod1,myPriceField1,MODE_MAIN  ,y);
            double stochs1 = iStochastic(NULL,timeFrames[k],StochasticK1,StochasticD1,StochasticSlowing1,SignalLineMaMethod1,myPriceField1,MODE_SIGNAL,y);
            bool isUp1 = (stochm1>stochs1);
            
            double stochm2 = iStochastic(NULL,timeFrames[k],StochasticK2,StochasticD2,StochasticSlowing2,SignalLineMaMethod2,myPriceField2,MODE_MAIN  ,y);
            double stochs2 = iStochastic(NULL,timeFrames[k],StochasticK2,StochasticD2,StochasticSlowing2,SignalLineMaMethod2,myPriceField2,MODE_SIGNAL,y);
            bool isUp2 = (stochm2>stochs2);

            double stochm3 = iStochastic(NULL,timeFrames[k],StochasticK3,StochasticD3,StochasticSlowing3,SignalLineMaMethod3,myPriceField3,MODE_MAIN  ,y);
            double stochs3 = iStochastic(NULL,timeFrames[k],StochasticK3,StochasticD3,StochasticSlowing3,SignalLineMaMethod3,myPriceField3,MODE_SIGNAL,y);
            bool isUp3 = (stochm3>stochs3);

            double stochm4 = iStochastic(NULL,timeFrames[k],StochasticK4,StochasticD4,StochasticSlowing4,SignalLineMaMethod4,myPriceField4,MODE_MAIN  ,y);
            double stochs4 = iStochastic(NULL,timeFrames[k],StochasticK4,StochasticD4,StochasticSlowing4,SignalLineMaMethod4,myPriceField4,MODE_SIGNAL,y);
            bool isUp4 = (stochm4>stochs4);

            double stochm5 = iStochastic(NULL,timeFrames[k],StochasticK5,StochasticD5,StochasticSlowing5,SignalLineMaMethod5,myPriceField5,MODE_MAIN  ,y);
            double stochs5 = iStochastic(NULL,timeFrames[k],StochasticK5,StochasticD5,StochasticSlowing5,SignalLineMaMethod5,myPriceField5,MODE_SIGNAL,y);
            bool isUp5 = (stochm5>stochs5);

            switch (k)
            {
               case 0 : if (isUp1) { sto1u[i] = k+1; sto1d[i] = EMPTY_VALUE;}  else { sto1d[i] = k+1; sto1u[i] = EMPTY_VALUE; } break;
               case 1 : if (isUp2) { sto2u[i] = k+1; sto2d[i] = EMPTY_VALUE;}  else { sto2d[i] = k+1; sto2u[i] = EMPTY_VALUE; } break;
               case 2 : if (isUp3) { sto3u[i] = k+1; sto3d[i] = EMPTY_VALUE;}  else { sto3d[i] = k+1; sto3u[i] = EMPTY_VALUE; } break;
               case 3 : if (isUp4) { sto4u[i] = k+1; sto4d[i] = EMPTY_VALUE;}  else { sto4d[i] = k+1; sto4u[i] = EMPTY_VALUE; } break;
               case 4 : if (isUp5) { sto5u[i] = k+1; sto5d[i] = EMPTY_VALUE;}  else { sto5d[i] = k+1; sto5u[i] = EMPTY_VALUE; } break;
            }
            if (isUp5)
                  trend[r][_up] += 1;
            else  trend[r][_dn] += 1;
      }
   }
   manageAlerts();
   return(0);
}
//+-------------------------------------------------------------------
void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = Bars-1;
      if (trend[whichBar][_up] >= alertsLevel || trend[whichBar][_dn] >= alertsLevel)
      {
         if (trend[whichBar][_up] >= alertsLevel) doAlert("up"  ,trend[whichBar][_up]);
         if (trend[whichBar][_dn] >= alertsLevel) doAlert("down",trend[whichBar][_dn]);
      }
   }
}
//+-------------------------------------------------------------------
void doAlert(string doWhat, int howMany)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || (alertsOnEachBar && previousTime != Time[0])) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" "+howMany+" time frames of stochastic are aligned "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" 6x Stochastic",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}
//-------------------------------------------------------------------
string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int toInt(double value) { return(value); }
int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   int max = ArraySize(iTfTable)-1, add=0;
   int nxt = (StringFind(tfs,"NEXT1")>-1); if (nxt>0) { tfs = ""+Period(); add=1; }
       nxt = (StringFind(tfs,"NEXT2")>-1); if (nxt>0) { tfs = ""+Period(); add=2; }
       nxt = (StringFind(tfs,"NEXT3")>-1); if (nxt>0) { tfs = ""+Period(); add=3; }
       nxt = (StringFind(tfs,"NEXT4")>-1); if (nxt>0) { tfs = ""+Period(); add=4; }
         
      for (int i=max; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[toInt(MathMin(max,i+add))],Period()));
                                                      return(Period());
}
//+-------------------------------------------------------------------
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
//+-------------------------------------------------------------------
string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int xchar = StringGetChar(s, length);
         if((xchar > 96 && xchar < 123) || (xchar > 223 && xchar < 256))
                     s = StringSetChar(s, length, xchar - 32);
         else if(xchar > -33 && xchar < 0)
                     s = StringSetChar(s, length, xchar + 224);
   }
   return(s);
}
//+-------------------------------------------------------------------
